//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAC41290027.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAC41290027.cm

//## begin module%3DAC41290027.cp preserve=no
//## end module%3DAC41290027.cp

//## Module: PlotGroup%3DAC41290027; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotGroup.cxx

//## begin module%3DAC41290027.additionalIncludes preserve=no
//## end module%3DAC41290027.additionalIncludes

//## begin module%3DAC41290027.includes preserve=yes
#include <GlobalContainer/DataContainer.h>
//## end module%3DAC41290027.includes

// PlotGroup
#include <XSPlot/Plot/PlotGroup.h>
// PlotStyle
#include <XSPlot/Plot/PlotStyle.h>
//## begin module%3DAC41290027.declarations preserve=no
//## end module%3DAC41290027.declarations

//## begin module%3DAC41290027.additionalDeclarations preserve=yes
#include <XSContainer.h>
//## end module%3DAC41290027.additionalDeclarations


// Class PlotGroup 

PlotGroup::PlotGroup (int arraySize, size_t nMods, bool useYdata)
  //## begin PlotGroup::PlotGroup%3D9878BD0219.hasinit preserve=yes
  : objectIndex(0),
    channelPlotSpacing(0),
    n(arraySize),
    is2Dcontour(false),
    critSignificance(0),
    critNumChans(1),
    errorType(PlotSettings::STD),
    single(false),
    lastInputChannel(0),
    bin(0),
    bundledPlotVectors(),
    plotVectorBoundaries(3),
    saveData(),
    background(),
    sources(nMods),
    xAxis(arraySize),
    yData(useYdata ? arraySize : 0),
    model(nMods + static_cast<size_t>(nMods > 1), PlotVector(arraySize)),
    auxData()
  //## end PlotGroup::PlotGroup%3D9878BD0219.hasinit
  //## begin PlotGroup::PlotGroup%3D9878BD0219.initialization preserve=yes
  //## end PlotGroup::PlotGroup%3D9878BD0219.initialization
{
  //## begin PlotGroup::PlotGroup%3D9878BD0219.body preserve=yes
  xAxis.styles.symbolStyle = PlotStyle::DOT;
  xAxis.errors.push_back(std::vector<Real>(arraySize,0));
  if (useYdata)
  {
     yData.errors.push_back(std::vector<Real>(arraySize,0));     
  }	

  //## end PlotGroup::PlotGroup%3D9878BD0219.body
}

PlotGroup::PlotGroup (const std::vector<Real>& xVals, const std::vector<Real>& yVals)
  //## begin PlotGroup::PlotGroup%4B4E1D29021E.hasinit preserve=no
  //## end PlotGroup::PlotGroup%4B4E1D29021E.hasinit
  //## begin PlotGroup::PlotGroup%4B4E1D29021E.initialization preserve=yes
  : objectIndex(0),
    channelPlotSpacing(0),
    n(xVals.size()*yVals.size()),
    is2Dcontour(true),
    critSignificance(0),
    critNumChans(0),
    errorType(PlotSettings::STD),
    single(false),
    lastInputChannel(0),
    bin(0),
    bundledPlotVectors(),
    plotVectorBoundaries(0),
    saveData(),
    background(),
    sources(),
    xAxis(xVals.size()),
    yData(yVals.size()),
    model(1),
    auxData()
  //## end PlotGroup::PlotGroup%4B4E1D29021E.initialization
{
  //## begin PlotGroup::PlotGroup%4B4E1D29021E.body preserve=yes
   xAxis.data = xVals;
   yData.data = yVals;
   model[0].data.resize(n);
  //## end PlotGroup::PlotGroup%4B4E1D29021E.body
}



//## Other Operations (implementation)
void PlotGroup::copyAttributes (const PlotGroup& right)
{
  //## begin PlotGroup::copyAttributes%4B6348E8014F.body preserve=yes
   channelPlotSpacing = right.channelPlotSpacing;
   critSignificance = right.critSignificance;
   critNumChans = right.critNumChans;
   errorType = right.errorType;
   single = right.single;
   lastInputChannel = right.lastInputChannel;
   bin = right.bin;
  //## end PlotGroup::copyAttributes%4B6348E8014F.body
}

//## begin module%3DAC41290027.epilog preserve=yes
bool operator< (const PlotGroup& left, const PlotGroup& right)
{
        return left.objectIndex < right.objectIndex;       
}
//## end module%3DAC41290027.epilog
